#include <iom8v.h>
#include <macros.h>
#include <stdlib.h>
//#include <eeprom.h>
#include <math.h>

#define SetBit(x,y) (x|=y)
#define ClrBit(x,y) (x&=~y)
#define TestBit(x,y) (x&y)

#define PORT_LED    PORTB
#define LED_RED     0b00000100
#define LED_GREEN   0b00000001

#define ALARM_1     0b00000001
#define ALARM_2     0b00000100
#define ALARM_3     0b00001000

#define ALARM_OFF   0b00000001
#define ALARM_ON	0b00000010

#define PORT_IO		PINC
#define PIN_ON		0b00000001
#define PIN_CLOSE	0b00000010
#define PIN_ALARM1	0b00000100
#define PIN_ALARM2  0b00001000
#define PIN_ALARM3  0b00010000

#define LCD_E		0b00010000
#define LCD_RW		0b01000000
#define LCD_RS		0b00100000
#define PORT_LCD	PORTC

unsigned char
uart_rx[200],
uart_tx[200],
uart_xx[200],
tSMSC[12],
//tSMSI[12],
rx_bit,
tx_bit,
xx_bit,
uart_error,
i,
f,
SMStext[50],
buffer[20],
status_ALARM=0,
status_CLICK=0,
aNomer[12]="79122652161";

unsigned char 
sALARM1[9]="1!",
sALARM2[9]="2!",
sALARM3[9]="3!";


unsigned int b;

#include "delay.h"
#include "uart.h"
#include "sms.h"

void uart0_init(void)
{
 UCSRB = 0x00; //disable while setting baud rate
 UCSRA = 0x00;
 UCSRC = BIT(URSEL) | 0x06;
 UBRRL = 0x03; //set baud rate lo
 UBRRH = 0x00; //set baud rate hi
 UCSRB = 0xF8;
}

void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0xE3; //setup
 TCNT1L = 0xE1;
 OCR1AH = 0x1C;
 OCR1AL = 0x1F;
 OCR1BH = 0x1C;
 OCR1BL = 0x1F;
 ICR1H  = 0x1C;
 ICR1L  = 0x1F;
 TCCR1A = 0x00;
 TCCR1B = 0x05; //start Timer
 TIMSK  = 0b00000100;
}

#pragma interrupt_handler timer1_ovf_isr:9
void timer1_ovf_isr(void)
{
 //TIMER1 has overflowed
 TCNT1H = 0xE3; //reload counter high value
 TCNT1L = 0xE1; //reload counter low value
 if((f==1)&&(status_CLICK>0)) 
 {
  PORT_LED^=LED_RED;
  b++;
  return;
 }
 if(status_ALARM==ALARM_ON)
 {
  SetBit(PORT_LED,LED_GREEN);
  Delay_ms(4);
  ClrBit(PORT_LED,LED_GREEN);
 }
}

void main(void)
{
 unsigned char c,str[10]; 
 f=0;
 DDRB=0xff;
 //DDRC=0xff;
 PORTB=0; 
 //PORTC=0xff;  
 Delay_ms(50); 
 uart0_init();
 timer1_init(); 
 status_ALARM=ALARM_OFF;
 SEI();
 
 start:
 
 i=0;
 uart_puts("ATE0"); 
 Delay_ms(5);
 
 i=0;
 uart_puts("ATE0"); 
 Delay_ms(5);
     
 i=0;
 uart_puts("AT+CPMS=\"MT\",\"SM\""); 
 Delay_ms(5);
 
 ReadSMSC();
 Delay_ms(5); 
  
 i=0;
 uart_puts("ATE0"); 
 Delay_ms(5);
  
 i=0;
 uart_puts("AT+CPBS=\"SM\""); 
 Delay_ms(5);
 
 i=0;
 uart_puts("AT+CSCS?"); 
 Delay_ms(5); 
 
 Delay_ms(2); 

 if((strlen(tSMSC)==11)&&(strlen(aNomer)==11)&&(strncmp(tSMSC,aNomer,11))) 
 {
  SetBit(PORT_LED,LED_RED+LED_GREEN);
  Delay_ms(100);
  ClrBit(PORT_LED,LED_GREEN);
  ClrBit(PORT_LED,LED_RED);
 }
 else
 {
  goto start;
 }
  
 monitor:
 if(status_CLICK!=0)
 {
      
  strcpy(SMStext,"");
 
  if(status_CLICK&ALARM_1) strcat(SMStext,sALARM1); 
  if(status_CLICK&ALARM_2) strcat(SMStext,sALARM2);
  if(status_CLICK&ALARM_3) strcat(SMStext,sALARM3);
 
  strcpy(buffer,"at+cmgs="); 
  c=strlen(SMStext);
  c=c*2+14;
  utoa(str,c,10);
  strcat(buffer,str);
  i=0;
  uart_puts(buffer);
  Delay_ms(5);
   
  CodeSMS(aNomer,SMStext);
  Delay_ms(5);
  uart_putsx();
  Delay_ms(5);
 }
 
 while(1)
 {
  while((PORT_IO&PIN_ON)==0)
  {
   if((PORT_IO&PIN_ON)==0)
   {
    status_ALARM=ALARM_OFF;
	status_CLICK=0;
	ClrBit(PORT_LED,LED_GREEN);
	ClrBit(PORT_LED,LED_RED);
	f=0;
   }
  }
  status_ALARM=ALARM_ON;  
  
  if((PORT_IO&PIN_CLOSE)&&(status_CLICK))
  {
   Delay_ms(2);
   if(PORT_IO&PIN_CLOSE)
   {
    status_CLICK=0;
	f=0;
    ClrBit(PORT_LED,LED_RED);
    f=0;
	//b=0;
   }
  }
  
  if((PORT_IO&PIN_ALARM1)) 
  {
   Delay_mks(500);
   if((PORT_IO&PIN_ALARM1)) SetBit(status_CLICK,ALARM_1);
  }
 
  if((PORT_IO&PIN_ALARM2)) 
  {
   Delay_mks(500);
   if((PORT_IO&PIN_ALARM2)) SetBit(status_CLICK,ALARM_2);
  }
  
  if((PORT_IO&PIN_ALARM3)) 
  {
   Delay_mks(500);
   if((PORT_IO&PIN_ALARM3)) SetBit(status_CLICK,ALARM_3);
  }
  
  if((status_CLICK!=0)&&(f==0))
  {
   f=1;
   b=0;
   goto monitor;
  }  
  
  if((status_CLICK!=0)&&(f==1)&&(b==60))
  {
   b=0;
   goto monitor;
  }    
 }
 return;
}
